// GPViewer.cpp : AvP[ṼNX`܂B
//

#include "stdafx.h"
#include "GPViewer.h"
#include "MainFrm.h"

#include "ChildFrm.h"
#include "GPViewerDoc.h"
#include "GPViewerView.h"
#include "input.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


int CALLBACK BrowseCallbackProc(HWND hwnd,UINT uMsg,LPARAM lParam,LPARAM lpData)
{
    if(uMsg==BFFM_INITIALIZED){
        SendMessage(hwnd,BFFM_SETSELECTION,(WPARAM)TRUE,lpData);
    }
    return 0;
}

void EnumDirectory( HWND hwnd, TCHAR *p_dir )
{
	BROWSEINFO bInfo;
    LPITEMIDLIST pIDList;
    TCHAR szDisplayName[MAX_PATH];

    bInfo.hwndOwner             = hwnd;
    bInfo.pidlRoot              = NULL;
    bInfo.pszDisplayName        = szDisplayName;
    bInfo.lpszTitle             = _T("tH_̑I");
    bInfo.ulFlags               = BIF_RETURNONLYFSDIRS | BIF_NEWDIALOGSTYLE;
    bInfo.lpfn                  = BrowseCallbackProc;
    bInfo.lParam                = (LPARAM)p_dir;
    
    pIDList = ::SHBrowseForFolder(&bInfo);
    if(pIDList == NULL)
	{
		//p_dir[0] = '\0';
    }
	else
	{
        if( ::SHGetPathFromIDList(pIDList, szDisplayName) )
		{
            _tcscpy( p_dir, szDisplayName );
        }
        ::CoTaskMemFree( pIDList );
    }
}

void GetFullpath( TCHAR *p_out, TCHAR *p_fn )
{
	TCHAR fn[512];
	TCHAR szPath[_MAX_PATH];
	GetModuleFileName( AfxGetApp()->m_hInstance, szPath, MAX_PATH);

	// tpX𕪉
	TCHAR szDir[_MAX_DIR];
	TCHAR szDrive[_MAX_DRIVE];
	TCHAR szFName[_MAX_FNAME];
	TCHAR szExt[_MAX_EXT];
	_tsplitpath(szPath,szDrive,szDir,szFName,szExt);

	// tH_At@C擾
	TCHAR szFilePath[512];
	TCHAR szFileName[512];
	_stprintf(szFilePath,_T("%s%s"),szDrive,szDir);
	_stprintf(szFileName,_T("%s%s"),szFName,szExt);
	_stprintf( fn, _T("%s%s"), szFilePath, p_fn );
	_tcscpy( p_out, fn );
}
// CGPViewerApp

BEGIN_MESSAGE_MAP(CGPViewerApp, CWinApp)
	ON_COMMAND(ID_APP_ABOUT, &CGPViewerApp::OnAppAbout)
	// W̃t@C{hLg R}h
//	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
//	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
	ON_COMMAND(ID_FILE_OPEN, &CGPViewerApp::OnFileOpen)
	ON_COMMAND(BTN_OPEN_SUBDIR, &CGPViewerApp::OnFileOpenSubDir)
	ON_COMMAND(ID_FILE_NEW, &CGPViewerApp::OnFileNew)

	ON_COMMAND(ID_ITEM_NEXT_NEW, &CGPViewerApp::OnItemNextNew)
//	ON_COMMAND(ID_ITEM_BACK_NEW, &CGPViewerApp::OnItemBackNew)
	ON_COMMAND(ID_ITEM_NEXT, &CGPViewerApp::OnItemNext)
	ON_COMMAND(ID_ITEM_BACK, &CGPViewerApp::OnItemBack)
	ON_COMMAND(ID_ITEM_NEXT_ACTIVE, &CGPViewerApp::OnItemNextActive)
	ON_COMMAND(ID_ITEM_BACK_ACTIVE, &CGPViewerApp::OnItemBackActive)

	ON_COMMAND(ID_DISP_THUMB, &CGPViewerApp::OnDispThumb)
END_MESSAGE_MAP()


// CGPViewerApp RXgNV

CGPViewerApp::CGPViewerApp()
{
	// TODO: ̈ʒuɍ\zpR[hǉĂB
	//  InitInstance ̏dvȏׂċLqĂB
	memset( m_RootDir, 0, sizeof(m_RootDir) );
	input_init();
	m_pDlgThumb = NULL;
}


// B CGPViewerApp IuWFNgłB

CGPViewerApp theApp;


// CGPViewerApp 

BOOL CGPViewerApp::InitInstance()
{
	m_FileList.clear();
	m_FileIndex = 0;
	memset( m_RootDir, 0, sizeof(m_RootDir) );

	// AvP[V }jtFXg visual X^CLɂ邽߂ɁA
	// ComCtl32.dll Version 6 ȍ~̎gpw肷ꍇ́A
	// Windows XP  InitCommonControlsEx() KvłBȂ΁AEBhE쐬ׂ͂Ďs܂B
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);
	// AvP[VŎgp邷ׂẴR Rg[ NX܂߂ɂ́A
	// ݒ肵܂B
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);
	GdiplusStartup(&m_gpToken, &m_gpStartupInput, NULL);

	CWinApp::InitInstance();

	// OLE Cu܂B
	if (!AfxOleInit())
	{
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();
	// W
	// ̋@\g킸ɍŏIIȎs\t@C
	// TCYkꍇ́Aȉsvȏ
	// [`폜ĂB
	// ݒ肪i[Ă郌WXg L[ύX܂B
	// TODO: Ж܂͑gDȂǂ̓K؂ȕ
	// ̕ύXĂB
	SetRegistryKey(_T("AvP[V EBU[hŐꂽ[J AvP[V"));
	LoadStdProfileSettings(0);  // W INI t@C̃IvV[h܂ (MRU ܂)
	if( m_pszProfileName ) {
		TCHAR str[512];
		delete ((void*)m_pszProfileName);
		m_pszProfileName = new TCHAR[MAX_PATH];
		if( !m_pszProfileName ) {
			AfxMessageBox( _T("sG[łB") );
			return FALSE;
		}
		GetFullpath( str, _T("GPViewer.INI") );
		_tcscpy( (TCHAR*)m_pszProfileName, str );
	}

	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		GetPrivateProfileString( _T("Config"), _T("ROOT"), _T(""), m_RootDir, sizeof(m_RootDir), inifile);
	}

	// AvP[Vp̃hLg ev[go^܂BhLg ev[g
	//  ̓hLgAt[ EBhEƃr[邽߂ɋ@\܂B
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(IDR_GPViewerTYPE,
		RUNTIME_CLASS(CGPViewerDoc),
		RUNTIME_CLASS(CChildFrame), // JX^ MDI qt[
		RUNTIME_CLASS(CGPViewerView));
	if (!pDocTemplate)
		return FALSE;
	AddDocTemplate(pDocTemplate);

	// C MDI t[ EBhE쐬܂B
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame || !pMainFrame->LoadFrame(IDR_MAINFRAME))
	{
		delete pMainFrame;
		return FALSE;
	}
	m_pMainWnd = pMainFrame;
	// ڔ݂ꍇɂ̂ DragAcceptFiles Ăяo܂B
	//  MDI AvP[Vł́ǍĂяóAm_pMainWnd ݒ肵ɔȂ΂Ȃ܂B


	// DDEAfile open ȂǕW̃VF R}h̃R}h C͂܂B
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	if (cmdInfo.m_nShellCommand == CCommandLineInfo::FileNew) {
        cmdInfo.m_nShellCommand = CCommandLineInfo::FileNothing;
    }

	// R}h CŎw肳ꂽfBXpb` R}hłBAvP[V
	// /RegServerA/RegisterA/Unregserver ܂ /Unregister ŋNꂽꍇAFalse Ԃ܂B
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// C EBhEꂽ̂ŁA\ƍXVs܂B
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	// TlC_CAO
	{
		m_pDlgThumb = new CDlgThumb;
		m_pDlgThumb->Create( DLG_THUMB, pMainFrame );
		m_pDlgThumb->m_ListThumb.CreateColumn();
		m_pDlgThumb->SetPos( pMainFrame );
		m_pDlgThumb->ShowWindow( SW_SHOW );
	}

	return TRUE;
}

void CGPViewerApp::SearchFile( CString dir, CString ext, int subdir )
{
	CFileFind FileFind;
	CString strSearchFile = (CString)dir + _T("\\*.*") /*+ (CString)ext*/;
	if(!FileFind.FindFile(strSearchFile)) {
		return; 
	}
    
	BOOL bContinue = TRUE;
	while(bContinue)
	{     
		bContinue = FileFind.FindNextFile();
		if(FileFind.IsDots()){
			continue; 
		}

		if(FileFind.IsDirectory()) {
			if( subdir ){
				SearchFile( FileFind.GetFilePath(), ext, subdir ); 
			}
		}
		else {
			FILEINF inf;
			TCHAR tmp[512] = { 0 };
			_tcscpy( tmp, FileFind.GetFileName() );
			_tcsupr( tmp );
			_tcscpy( inf.path, FileFind.GetFilePath() );
			if( _tcsstr( tmp, ext ) )
			{
				inf.type = FT_JPG;
				m_FileList.push_back( inf );
			}

			m_pDlgThumb->Regist( FileFind.GetFilePath() );
		}
    }
}
void CGPViewerApp::OnFileOpen()
{
	m_FileIndex = 0;
	m_FileList.clear();
	EnumDirectory( AfxGetMainWnd()->m_hWnd, m_RootDir );

	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		WritePrivateProfileString( _T("Config"), _T("ROOT"),  m_RootDir, inifile);
	}

	
	if( _tcslen( m_RootDir ) ){
		m_pDlgThumb->Clear();
		SearchFile( m_RootDir, _T("JPG") );
	}
	
	if( m_FileList.size() ){
		FILEINF inf = m_FileList.at( m_FileIndex );
		OpenDocumentFile( inf.path );
	}
}

void CGPViewerApp::OnFileOpenSubDir()
{
	m_FileIndex = 0;
	m_FileList.clear();
	EnumDirectory( AfxGetMainWnd()->m_hWnd, m_RootDir );

	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		WritePrivateProfileString( _T("Config"), _T("ROOT"),  m_RootDir, inifile);
	}

	if( _tcslen( m_RootDir ) ){
		m_pDlgThumb->Clear();
		SearchFile( m_RootDir, _T("JPG"), 1 );
	}
	
	if( m_FileList.size() ){
		FILEINF inf = m_FileList.at( m_FileIndex );
		OpenDocumentFile( inf.path );
	}
}

void CGPViewerApp::OnFileNew()
{
	if( m_FileIndex + 1 < m_FileList.size() ){
		m_FileIndex ++;
	}
	else {
		m_FileIndex = 0;
	}
	if( m_FileList.size() ){
		FILEINF inf = m_FileList.at( m_FileIndex );
		OpenDocumentFile( inf.path );
	}
}

int CGPViewerApp::ItemNext( CString &fn )
{
	fn = "";
	if( m_FileIndex + 1 < m_FileList.size() ){
		m_FileIndex ++;
	}
	else {
		m_FileIndex = 0;
	}
	if( m_FileList.size() ){
		FILEINF inf = m_FileList.at( m_FileIndex );
		fn = inf.path;
	}
	else {
		return -1;
	}

	return 0;
}

int CGPViewerApp::ItemBack( CString &fn )
{
	fn = "";
	if( m_FileIndex > 0){
		m_FileIndex --;
	}
	else {
		m_FileIndex = m_FileList.size()-1;
	}

	if( m_FileList.size() ){
		FILEINF inf = m_FileList.at( m_FileIndex );
		fn = inf.path;
	}
	else {
		return -1;
	}
	return 0;
}

int CGPViewerApp::ItemGoto( CString &fn, int index )
{
	fn = "";
	/*
	if( m_FileIndex > 0){
		m_FileIndex --;
	}
	else {
		m_FileIndex = m_FileList.size()-1;
	}
	*/
	m_FileIndex = index;

	if( m_FileList.size() ){
		FILEINF inf = m_FileList.at( m_FileIndex );
		fn = inf.path;
	}
	else {
		return -1;
	}
	return 0;
}

void CGPViewerApp::OnItemNextNew()
{
	CString fn;
	if( ItemNext( fn ) == 0 ){
		OpenDocumentFile( fn );
	}
}

void CGPViewerApp::OnItemBackNew()
{
	CString fn;

	if( ItemBack( fn ) == 0 ){
		OpenDocumentFile( fn );
	}
}

void CGPViewerApp::OnItemGoto( int index )
{
	CString fn;
	if( ItemGoto( fn, index ) == 0 ){
		CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
		if( pmain ){
			CView* phview = ( CView* )( pmain->MDIGetActive()->GetWindow( GW_CHILD ));
			if( phview ){
				CGPViewerView* pView = STATIC_DOWNCAST( CGPViewerView, phview );
				CGPViewerDoc* pDoc = pView->GetDocument();
				pDoc->SetPathName( fn );
				pDoc->SetTitle( fn );
				pView->Reload();
			}
		}
	}
}

void CGPViewerApp::OnItemNext()
{
	CString fn;
	if( ItemNext( fn ) == 0 ){
		CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
		if( pmain ){
			CView* phview = ( CView* )( pmain->MDIGetActive()->GetWindow( GW_CHILD ));
			if( phview ){
				CGPViewerView* pView = STATIC_DOWNCAST( CGPViewerView, phview );
				CGPViewerDoc* pDoc = pView->GetDocument();
				pDoc->SetPathName( fn );
				pDoc->SetTitle( fn );
				pView->Reload();
			}
		}
	}
}

void CGPViewerApp::OnItemBack()
{
	CString fn;
	if( ItemBack( fn ) == 0 ){
		CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
		if( pmain ){
			CView* phview = ( CView* )( pmain->MDIGetActive()->GetWindow( GW_CHILD ));
			if( phview ){
				CGPViewerView* pView = STATIC_DOWNCAST( CGPViewerView, phview );
				CGPViewerDoc* pDoc = pView->GetDocument();
				pDoc->SetPathName( fn );
				pDoc->SetTitle( fn );
				pView->Reload();
			}
		}
	}
}

void CGPViewerApp::OnItemNextActive()
{
	CString fn;
	if( ItemBack( fn ) == 0 ){
		CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
		if( pmain ){
			pmain->MDIPrev();
		}
	}
}
void CGPViewerApp::OnItemBackActive()
{
	CString fn;
	if( ItemBack( fn ) == 0 ){
		CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
		if( pmain ){
			pmain->MDINext();
		}
	}
}

void CGPViewerApp::OnDispThumb()
{
	if( m_pDlgThumb ){
		m_pDlgThumb->ShowWindow( SW_SHOW );
	}
}

// AvP[Ṽo[WɎg CAboutDlg _CAO

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// _CAO f[^
	enum { IDD = IDD_ABOUTBOX };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV T|[g

// 
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// _CAOs邽߂̃AvP[V R}h
void CGPViewerApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}


// CGPViewerApp bZ[W nh


int CGPViewerApp::ExitInstance()
{
	// TODO: ɓȃR[hǉ邩A͊{NXĂяoĂB
	if( m_pDlgThumb ){
		delete m_pDlgThumb;
		m_pDlgThumb = NULL;
	}
	return CWinApp::ExitInstance();
}
