// MainFrm.cpp : CMainFrame NX̎
//

#include "stdafx.h"
#include "GPViewer.h"
#include "GPViewerDoc.h"
#include "GPViewerView.h"

#include "MainFrm.h"
#include "input.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	ON_WM_CREATE()
	ON_WM_TIMER()
//	ON_COMMAND(ID_ITEM_W_0320, &CMainFrame::W0320 )
	ON_COMMAND(ID_ITEM_W_0240, &CMainFrame::W0240 )
//	ON_COMMAND(ID_ITEM_W_0640, &CMainFrame::W0640 )
	ON_COMMAND(ID_ITEM_W_0480, &CMainFrame::W0480 )
//	ON_COMMAND(ID_ITEM_W_0800, &CMainFrame::W0800 )
	ON_COMMAND(ID_ITEM_W_0600, &CMainFrame::W0600 )
//	ON_COMMAND(ID_ITEM_W_1024, &CMainFrame::W1024 )
//	ON_COMMAND(ID_ITEM_W_0768, &CMainFrame::W0768 )
	ON_COMMAND(ID_ITEM_CW, &CMainFrame::WCustom )
	ON_WM_MOUSEWHEEL()
END_MESSAGE_MAP()


// CMainFrame RXgNV/fXgNV

CMainFrame::CMainFrame()
{
	// TODO: oR[hɒǉĂB
}

CMainFrame::~CMainFrame()
{
}


int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("c[ o[̍쐬Ɏs܂B\n");
		return -1;      // 쐬ł܂łB
	}

	// TODO: c[ o[hbLO\ɂȂꍇ́A 3 s폜ĂB
//	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
//	EnableDocking(CBRS_ALIGN_ANY);
//	DockControlBar(&m_wndToolBar);

	input_init();
	SetTimer( 0x1234, 16, NULL );
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: ̈ʒu CREATESTRUCT cs C Window NX܂̓X^C
	//  CĂB
	
	return TRUE;
}


// CMainFrame ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG


// CMainFrame bZ[W nh




void CMainFrame::OnTimer(UINT_PTR nIDEvent)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
	if( pmain ){
		CMDIChildWnd* pchild = pmain->MDIGetActive();
		if( pchild )
		{
			CView* phview = ( CView* )(pchild->GetWindow( GW_CHILD ));
			if( phview ){
				CGPViewerView* pView = STATIC_DOWNCAST( CGPViewerView, phview );
				CGPViewerDoc* pDoc = pView->GetDocument();
				input_update( pView->m_hWnd );

				if( GetActiveWindow() == this ){
					pView->UpdateInput();
				}
			}
		}
	}
	CMDIFrameWnd::OnTimer(nIDEvent);
}

void CMainFrame::AdjustWindow( int w, int h )
{
	CMainFrame* pmain = STATIC_DOWNCAST( CMainFrame, AfxGetMainWnd() );
	if( pmain ){
		CMDIChildWnd* pChild = pmain->MDIGetActive();
		if( pChild )
		{
			CGPViewerView* pView = ( CGPViewerView* )(pChild->GetWindow( GW_CHILD ));
			if( pView ){
				input_update( pView->m_hWnd );

				if( GetActiveWindow() == this )
				{
					int pos_w = 0;
					int pos_h = 0;
					CRect rc;
					pChild->GetWindowRect( &rc );
					for( int i = 0; i < 100; i ++ ){
						pChild->SetWindowPos( NULL, 0, 0, w+pos_w, h+pos_h, SWP_NOMOVE|SWP_NOZORDER );//MoveWindow( rc.left, rc.top, w+pos_w, h+pos_h, FALSE );
						CRect c;
						pView->GetClientRect( &c );
						if( c.Width() == w ){
							break;
						}
						if( c.Width() < w ){
							pos_w ++;
						}
						if( c.Width() > w ){
							pos_w --;
						}
					}

					pChild->GetWindowRect( &rc );
					for( int i = 0; i < 100; i ++ ){
						pChild->SetWindowPos( NULL, 0, 0, w+pos_w, h+pos_h, SWP_NOMOVE|SWP_NOZORDER );//MoveWindow( rc.left, rc.top, w+pos_w, h+pos_h, FALSE );
						CRect c;
						pView->GetClientRect( &c );
						if( c.Height() == h ){
							break;
						}
						if( c.Height() < h ){
							pos_h ++;
						}
						if( c.Height() > h ){
							pos_h --;
						}
					}
					this->Invalidate( FALSE );
				}
			}
		}
	}
}

void CMainFrame::W0320()
{
	AdjustWindow( 320, 240 );
}
void CMainFrame::W0240()
{
	AdjustWindow( 240, 320 );
}
void CMainFrame::W0640()
{
	AdjustWindow( 640, 480 );
}
void CMainFrame::W0480()
{
	AdjustWindow( 480, 640 );
}
void CMainFrame::W0800()
{
	AdjustWindow( 800, 600 );
}
void CMainFrame::W0600()
{
	AdjustWindow( 600, 800 );
}
void CMainFrame::W1024()
{
	AdjustWindow( 1024, 768 );
}
void CMainFrame::W0768()
{
	AdjustWindow( 768, 1024 );
}
void CMainFrame::WCustom()
{
	int w = 0;
	int h = 0;
	{
		TCHAR inifile[512];
		GetFullpath( inifile, _T("GPViewer.INI") );
		w = GetPrivateProfileInt( _T("Config"), _T("CWinW"), 480, inifile);
		h = GetPrivateProfileInt( _T("Config"), _T("CWinH"), 854, inifile);
	}
	AdjustWindow( w, h );
}

BOOL CMainFrame::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	// TODO: ɃbZ[W nh R[hǉ邩ȀĂяo܂B
	if( zDelta < 0 ){
		CGPViewerApp *p_app = (CGPViewerApp*)AfxGetApp();
		if( p_app ){
			
			p_app->OnItemNext();
		}
	}
	else {
		CGPViewerApp *p_app = (CGPViewerApp*)AfxGetApp();
		if( p_app ){
			p_app->OnItemBack();
		}
	}
	return CMDIFrameWnd::OnMouseWheel(nFlags, zDelta, pt);
}
