/*
	L[̓Cu
*/
#include "stdafx.h"
#include <windows.h>
#include "input.h"

PADINFO	g_PadInfo;
static int CheckKeyCode[ KEY_MAX ] = 
{
	VK_LBUTTON, VK_RBUTTON, VK_UP, VK_DOWN, VK_RIGHT, VK_LEFT, VK_SPACE, VK_RETURN,
	'V', 'C', 'X', 'F', 'D', 'S', 'A', VK_CONTROL,
};

PADINFO *pad( void )
{
	return &g_PadInfo;
}

DWORD input_pad( void )
{
	return g_PadInfo.pad;
}
DWORD input_padt( void )
{
	return g_PadInfo.padt;
}
DWORD input_padr( void )
{
	return g_PadInfo.padr;
}
int input_mx( void )
{
	return g_PadInfo.mx;
}
int input_my( void )
{
	return g_PadInfo.my;
}
int input_mdx( void )
{
	return g_PadInfo.mdx;
}
int input_mdy( void )
{
	return g_PadInfo.mdy;
}
void input_init( void )
{
	memset( &g_PadInfo, 0, sizeof(PADINFO) );
}

void input_update( HWND hwnd )
{
	int i;
	PADINFO	*pad = &g_PadInfo; 
	DWORD pad_old = pad->pad;

	pad->pad  = 0;
	pad->padt = 0;
	pad->padr = 0;

	for( i = 0; i < KEY_MAX; i ++ )
	{
		if( (GetKeyState(CheckKeyCode[i])&0x80) )
		{
			pad->pad |= ( 1 << i );
		}
	}

	pad->padt = (pad->pad ^ pad_old) & pad->pad;

	pad->repeat_wait ++;
	if( pad->repeat_wait > pad->repeat_time )
	{
		pad->repeat_wait = 0;
		pad->padr = pad->padr_old & pad->pad;
		pad->padr_old = pad->pad;
	}

	POINT point;
	GetCursorPos( &point );
	ScreenToClient( hwnd, &point);
	//MapWindowPoints( HWND_DESKTOP, hwnd, &point, 1 );
	point.x -= MX_OFST;
	point.y -= MY_OFST;

	pad->mx_old = pad->mx;
	pad->my_old = pad->my;

	pad->mx = point.x;
	pad->my = point.y;

	pad->mdx = pad->mx - pad->mx_old;
	pad->mdy = pad->my - pad->my_old;
}

